// variable declaration
var selfDealer, dealerInfoObj;
var validated, validName, validMobNum, validEmail, validPin, validAddr, validateGPS;
var fosOutlet, townLocality, languages, education, prevOccupation, familyBG;

//class declaration
function CreateDealer() {
	selfDealer = this;
};

dealerInfoObj = new CreateDealer();

// class properties 
CreateDealer.prototype.TScreateFOSRoleID = "";
CreateDealer.prototype.TScreateDealerName = "";
CreateDealer.prototype.TScreateDealerNumber = "";
CreateDealer.prototype.TScreateDealerEmail = "";
CreateDealer.prototype.TScreateDealerDirectSale = "";
CreateDealer.prototype.TScreateDealerAddress1 = "";
CreateDealer.prototype.TScreateDealerAddress2 = "";
CreateDealer.prototype.TScreateDealerPinCode = "";
CreateDealer.prototype.TScreateDealerCircle = "";
CreateDealer.prototype.TScreateDealerCircleID = "";
CreateDealer.prototype.TScreateDealerDistMDN = "";
CreateDealer.prototype.TScreateDealerUniqueCode = "";
CreateDealer.prototype.TScreateDealerAge = "";
CreateDealer.prototype.TScreateDealerEducation = "";
CreateDealer.prototype.TScreateDealerEducationID = "";
CreateDealer.prototype.TScreateDealerPreOccu = "";
CreateDealer.prototype.TScreateDealerPreOccuID = "";
CreateDealer.prototype.TScreateDealerFamilyBg = "";
CreateDealer.prototype.TScreateDealerFamilyBgID = "";
CreateDealer.prototype.TScreateDealerOutletType = "";
CreateDealer.prototype.TScreateDealerOutletID = "";
CreateDealer.prototype.TScreateDealerLocality = "";
CreateDealer.prototype.TScreateDealerTownCode = "";
CreateDealer.prototype.TScreateDealerPriLang = "";
CreateDealer.prototype.TScreateDealerPriLangID = "";
CreateDealer.prototype.TScreateDealerSecLang = "";
CreateDealer.prototype.TScreateDealerSecLangID = "";
CreateDealer.prototype.TScreateDealerLatitude = "";
CreateDealer.prototype.TScreateDealerLongitude = "";

// Default Values of Drop Downs
CreateDealer.prototype.defaultTownLocality = $("#TScreateDealerLocality").find(":selected").text();
CreateDealer.prototype.defaultOutletType = $("#TScreateDealerOutletType").find(":selected").text();
CreateDealer.prototype.defaultEducation = $("#TScreateDealerEducation").find(":selected").text();
CreateDealer.prototype.defaultPrevOccu = $("#TScreateDealerPreOccu").find(":selected").text();
CreateDealer.prototype.defaultFamilyBG = $("#TScreateDealerFamilyBg").find(":selected").text();
CreateDealer.prototype.defaultPriLang = $("#TScreateDealerPriLang").find(":selected").text();
CreateDealer.prototype.defaultSecLang = $("#TScreateDealerSecLang").find(":selected").text();

// class methods

CreateDealer.prototype.getFOSInfo = function (adapterName, procedureName, parameters) {
	serviceObj.callAdapter(adapterName, procedureName, parameters, configObj.modules.getFOSInfo);
};

CreateDealer.prototype.getFOSInfoSuccess = function (res) {
	try {
		// Resetting the variables
		validated = validName = validMobNum = validEmail = validPin = validAddr = validateGPS = false;

		$("#TScreateDealerFOSID").val(loginObj.userName);

		selfDealer.TScreateFOSRoleID = res.userDetails[0].ROLE_ID;
		selfDealer.TScreateDealerCircleID = res.fosDetails[0].CIRCLE_ID;

		selfDealer.TScreateDealerDistMDN = res.fosDetails[0].DISTRIBUTOR_MDN
		$("#TScreateDealerDistMDN").val(selfDealer.TScreateDealerDistMDN);

		selfDealer.TScreateDealerCircle = res.fosDetails[0].CIRCLE_DESC;
		$("#TScreateDealerCircle").val(selfDealer.TScreateDealerCircle);

		// Settings direct sales radio button values
		$('#TScreateDealerDSYes').val('Y');
		$('#TScreateDealerDSNo').val('N');

		//Resetting All Dropdowns
		resetDropDowns("#TScreateDealerOutletType", selfDealer.defaultOutletType);
		resetDropDowns("#TScreateDealerLocality", selfDealer.defaultTownLocality);
		resetDropDowns("#TScreateDealerEducation", selfDealer.defaultEducation);
		resetDropDowns("#TScreateDealerPreOccu", selfDealer.defaultPrevOccu);
		resetDropDowns("#TScreateDealerFamilyBg", selfDealer.defaultFamilyBG);
		resetDropDowns("#TScreateDealerPriLang", selfDealer.defaultPriLang);
		resetDropDowns("#TScreateDealerSecLang", selfDealer.defaultSecLang);
	} catch (ex) {
		showAlert("error", Messages.catchError);
		return;
	}
}

CreateDealer.prototype.getFOSInfoFailure = function (res) {
	try {
		console.log("failure function");
		if(commonObj.isVisible()) {
			commonObj.hideBusy();
		}
		console.log(JSON.stringify(res));
		if (res.status == "failure") {
			showAlert("error", res.errorMessage);
		}
	} catch (ex) {
		console.log(ex);
	}
}

CreateDealer.prototype.validate = function () {
	try {
		console.log("inside create dealer method validate function");
		selfDealer.TScreateDealerName = $('#TScreateDealerName').val();
		selfDealer.TScreateDealerNumber = $('#TScreateDealerNumber').val();
		selfDealer.TScreateDealerEmail = $('#TScreateDealerEmail').val();
		selfDealer.TScreateDealerDirectSale = $("input[name='TScreateDealerDirectSale']:checked").val();
		selfDealer.TScreateDealerAddress1 = $('#TScreateDealerAddress1').val();
		selfDealer.TScreateDealerAddress2 = $('#TScreateDealerAddress2').val();
		selfDealer.TScreateDealerPinCode = $('#TScreateDealerPinCode').val();

		validateName();
		if(validName){
			validateMobileNumber();
			if(validMobNum) {
				validateEmail();
				if(validEmail) {
					validateAddress();
					if(validAddr) {
						validatePincode();
						if(validPin) {
							var parameters = [
								loginObj.userName,
								selfDealer.TScreateDealerCircle,
								selfDealer.TScreateDealerDistMDN,
								selfDealer.TScreateDealerName,
								selfDealer.TScreateDealerNumber,
								selfDealer.TScreateDealerEmail,
								selfDealer.TScreateDealerDirectSale,
								selfDealer.TScreateDealerAddress1,
								selfDealer.TScreateDealerAddress2,
								selfDealer.TScreateDealerPinCode
							];
							selfDealer.validateDealerInfo(configObj.adapter.FosDealerCreation, configObj.procedure.validateDealerDetails, parameters);
							//selfDealer.validateDealerInfoSuccess(1);
						}
					}
				}
			}
		}
	} catch (ex) {
		console.log(ex);
		showAlert("error", Messages.catchError);
		return;
	}
};

function resetDropDowns(elemID, defaultText) {
	$(elemID).empty();
	$(elemID).prepend("<option value='' selected>" + defaultText + "</option>");
	$(elemID).selectmenu();
	$(elemID).selectmenu("refresh");
}

function validateName() {
	var regexName = /^[a-zA-Z\s]*$/;
	
	if (selfDealer.TScreateDealerName === "") {
		showAlert("alert", Messages.emptyName);
	} else {
		if(!regexName.test(selfDealer.TScreateDealerName)) {
			showAlert("alert", Messages.validName);
		} else {
			if(selfDealer.TScreateDealerName.length < 3) {
				showAlert("alert", Messages.nameLength);
			} else {
				console.log("valid Name");
				validName = true;
			}
		}
	}
}

function validateMobileNumber() {
	var regexNumber = /^[0-9]*$/;

	if (selfDealer.TScreateDealerNumber === "") {
		showAlert("alert", Messages.emptyMobileNumber);
	} else {
		if(!regexNumber.test(selfDealer.TScreateDealerNumber)) {
			showAlert("alert", Messages.validMobileNo);
		}
		else {
			if (selfDealer.TScreateDealerNumber.charAt(0) < "6") {
				showAlert("alert", Messages.mobileValidation);
			} else {
				if(selfDealer.TScreateDealerNumber.length < 10) {
					console.log("less than 10 numbers");
					showAlert("alert", Messages.mobileValidationMsgStock);
				} else {
					console.log("valid mobile number");
					validMobNum = true;
				}
			}
		}
	}
}
function validateEmail() {
	var regexEmail = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;

	if(selfDealer.TScreateDealerEmail === "") { //email is Optional
		console.log("valid Email"); 
		validEmail = true;
	} else {
		validEmail = false;
		if (!regexEmail.test(selfDealer.TScreateDealerEmail)) {
			showAlert("alert", Messages.validEmailAddress);
		} else {
			console.log("valid Email");
			validEmail = true;
		}
	}
}

function validateAddress() {
	if(selfDealer.TScreateDealerAddress1 === "") {
		showAlert("alert", Messages.emptyAddLine1);
	} else {
		console.log("valid Address 1");
		// Address1 validation ends; Address2 validation starts
		if(selfDealer.TScreateDealerAddress2 === "") {
			showAlert("alert", Messages.emptyAddLine2);
		} else {
			console.log("valid Address 2");
			validAddr = true;
		}
	}
}

function validatePincode() {
	var regexPin = /^[0-9]*$/;

	if (selfDealer.TScreateDealerPinCode === "") {
		showAlert("alert", Messages.emptyPincode);
	} else {
		if(!regexPin.test(selfDealer.TScreateDealerPinCode)) {
			showAlert("alert", Messages.validPincode);
		} else {
			if (selfDealer.TScreateDealerPinCode.length < 6) {
				showAlert("alert", Messages.pincodeLength);
			} else {
				console.log("valid PIN code");
				validPin = true;
			}
		}
	}
}

//functions for validating
CreateDealer.prototype.validateDealerInfo = function (adapterName, procedureName, parameters) {
	serviceObj.callAdapter(adapterName, procedureName, parameters, configObj.modules.validateNewDealer);
};

CreateDealer.prototype.validateDealerInfoSuccess = function (res) {
	try {
		// showAlert("message", "inside validateDealerInfoSuccess");
		validated = true;

		selfDealer.TScreateDealerCity = res.cityDetails[0].BILL_CITY;
		$("#TScreateDealerCity").val(res.cityDetails[0].BILL_CITY);

		selfDealer.TScreateDealerDistrict = res.cityDetails[0].BILL_DIST;
		$("#TScreateDealerDistrict").val(res.cityDetails[0].BILL_DIST);

		$("#TScreateDealerLocality").empty();
		$("#TScreateDealerLocality").prepend("<option value='' selected >Select Town Locality</option>");
		
		townLocality = res.townDetails.list;
		for (var i = 0; i < townLocality.length; i++) {
			$( '#TScreateDealerLocality').append($('<option>', {
				value: townLocality[i].town,
				text: townLocality[i].town
			}));
		}

		$("#TScreateDealerLocality").selectmenu();
		$("#TScreateDealerLocality").selectmenu("refresh");

		//Empty the town code and unique town code fields if it already has some value
		$("#TScreateDealerTownCode").val("");
		$("#TScreateDealerUniqueCode").val("");

		// $('#TSCreateDealer .pageContent')[0].scrollTop = $('#TSCreateDealer .pageContent')[0].scrollHeight;
		$("#TScreateDealerValidate").get(0).scrollIntoView();
	} catch (ex) {
		showAlert("error", Messages.catchError);
		return;
	}
}

CreateDealer.prototype.validateDealerInfoFailure = function (res) {
	try {
		console.log("validateDealerInfoFailure failure function" + JSON.stringify(res));
		if(commonObj.isVisible()) {
			commonObj.hideBusy();
		}
		if (res.status == "failure") {
			showAlert("error", res.errorMessage);
		}
	} catch (ex) {
		console.log(ex);
	}
}

CreateDealer.prototype.localityCheck = function (adapterName, procedureName, parameters) {
	serviceObj.callAdapter(adapterName, procedureName, parameters, configObj.modules.checkTownLocality);
};

CreateDealer.prototype.localityCheckSuccess = function (res) {
try {
	console.log(res);
	selfDealer.TScreateDealerTownCode = res.townCode[0].BILL_TOWN+" ~ "+res.townCode[0].UNIQUE_TOWN_CODE_TSL;
	$("#TScreateDealerTownCode").val(selfDealer.TScreateDealerTownCode);

	$("#TScreateDealerOutletType").empty();
	$("#TScreateDealerOutletType").prepend("<option value='' selected >Select Outlet Type</option>");
	fosOutlet = res.fosDetailsOutlet;
	for (var i = 0; i < fosOutlet.length; i++) {
		$('#TScreateDealerOutletType').append($('<option>', {
			value: fosOutlet[i].OUTLET_TYPE,
			text: fosOutlet[i].OUTLET_TYPE
		}));
	}

	$("#TScreateDealerOutletType").selectmenu();
	$("#TScreateDealerOutletType").selectmenu("refresh");

	// $('#TSCreateDealer .pageContent')[0].scrollTop = $('#TSCreateDealer .pageContent')[0].scrollHeight;
	$("#TScreateDealerLocality").get(0).scrollIntoView();
	} catch (ex) {
		showAlert("error", Messages.catchError);
		return;
	}
};

CreateDealer.prototype.localityCheckFailure = function (res) {
	try {
		if(commonObj.isVisible()) {
			commonObj.hideBusy();
		}
		console.log("failure function");
		console.log(JSON.stringify(res));

		resetDropDowns("#TScreateDealerOutletType", selfDealer.defaultOutletType);

		if (res.status == "failure") {
			showAlert("error", res.errorMessage);
		}
	} catch (ex) {
		console.log(ex);
	}
}

CreateDealer.prototype.selectOutletType = function (adapterName, procedureName, parameters) {
	serviceObj.callAdapter(adapterName, procedureName, parameters, configObj.modules.outletType);
};

CreateDealer.prototype.selectOutletTypeSuccess = function (res) {
	try {
		$("#TScreateDealerAge").val(""); //Empty the Age if already filled
		$("#TScreateDealerUniqueCode").val(""); //Empty the Unique Code if already filled

		// Resetting drop downs and ID variables
		resetDropDowns("#TScreateDealerEducation", selfDealer.defaultEducation);
		resetDropDowns("#TScreateDealerPreOccu", selfDealer.defaultPrevOccu);
		resetDropDowns("#TScreateDealerFamilyBg", selfDealer.defaultFamilyBG);
		selfDealer.TScreateDealerEducationID = "";
		selfDealer.TScreateDealerPreOccuID = "";
		selfDealer.TScreateDealerFamilyBgID = "";

		if(selfDealer.TScreateDealerOutletType.substr(0,4) === "Sonu") {
			$("#age1").show();
			$("#edu1").show();
			$("#preOcc1").show();
			$("#famBg1").show();
			$("#uniqueCode").show();

			$("#TScreateDealerEducation").empty();
			$("#TScreateDealerEducation").prepend("<option value='' selected >Select Education</option>");

			education = res.education;
			for (var i = 0; i < education.length; i++) {
				$('#TScreateDealerEducation').append($('<option>', {
					value: education[i].NAME,
					text: education[i].NAME
				}));
			}

			$("#TScreateDealerEducation").selectmenu();
			$("#TScreateDealerEducation").selectmenu("refresh");
	
			$("#TScreateDealerPreOccu").empty();
			$("#TScreateDealerPreOccu").prepend("<option value='' selected >Select Previous Occupation</option>");

			prevOccupation = res.prevOccupation;
			for (var i = 0; i < prevOccupation.length; i++) {
				$('#TScreateDealerPreOccu').append($('<option>', {
					value: prevOccupation[i].NAME,
					text: prevOccupation[i].NAME
				}));
			}

			$("#TScreateDealerPreOccu").selectmenu();
			$("#TScreateDealerPreOccu").selectmenu("refresh");

			$("#TScreateDealerFamilyBg").empty();
			$("#TScreateDealerFamilyBg").prepend("<option value='' selected >Select Family Background</option>");
	
			familyBG = res.famBackground;
			for (var i = 0; i < familyBG.length; i++) {
				$('#TScreateDealerFamilyBg').append($('<option>', {
					value: familyBG[i].NAME,
					text: familyBG[i].NAME
				}));
			}

			$("#TScreateDealerFamilyBg").selectmenu();
			$("#TScreateDealerFamilyBg").selectmenu("refresh");
		} else {
			$("#age1").hide();
			$("#edu1").hide();
			$("#preOcc1").hide();
			$("#famBg1").hide();
			$("#uniqueCode").hide();
		}

		$("#TScreateDealerPriLang").empty();
		$("#TScreateDealerPriLang").prepend("<option value='' selected >Select Primary Language</option>");

		$("#TScreateDealerSecLang").empty();
		$("#TScreateDealerSecLang").prepend("<option value='' selected >Select Secondary Language</option>");

		languages = res.langPriSecond;
		for (var i = 0; i < languages.length; i++) {
			$('#TScreateDealerPriLang').append($('<option>', {
				value: languages[i].LANGUAGE_NAME,
				text: languages[i].LANGUAGE_NAME
			}));

			$('#TScreateDealerSecLang').append($('<option>', {
				value: languages[i].LANGUAGE_NAME,
				text: languages[i].LANGUAGE_NAME
			}));
		}

		$("#TScreateDealerPriLang").selectmenu();
		$("#TScreateDealerPriLang").selectmenu("refresh");
		
		$("#TScreateDealerSecLang").selectmenu();
		$("#TScreateDealerSecLang").selectmenu("refresh");

		// $('#TSCreateDealer .pageContent')[0].scrollTop = $('#TSCreateDealer .pageContent')[0].scrollHeight;
		$("#TScreateDealerOutletType").get(0).scrollIntoView();
	} catch (ex) {
		showAlert("error", Messages.catchError);
		return;
	}
}

CreateDealer.prototype.selectOutletTypeFailure = function (res) {
	try {
		if(commonObj.isVisible()) {
			commonObj.hideBusy();
		}
		console.log("selectOutletypeFailure failure function" + JSON.stringify(res));
		
		resetDropDowns("#TScreateDealerPriLang", selfDealer.defaultPriLang);
		resetDropDowns("#TScreateDealerSecLang", selfDealer.defaultSecLang);
				
		if (res.status == "failure") {
			showAlert("error", res.errorMessage);
		}
	} catch (ex) {
		console.log(ex);
	}
}

CreateDealer.prototype.validateDealerForm = function (){
	try {
		selfDealer.TScreateDealerCity = $('#TScreateDealerCity').val();
		selfDealer.TScreateDealerDistrict = $('#TScreateDealerDistrict').val();
		selfDealer.TScreateDealerLocality = $("#TScreateDealerLocality").find(":selected").text();
		selfDealer.TScreateDealerTownCode = $('#TScreateDealerTownCode').val();
		selfDealer.TScreateDealerOutletType = $("#TScreateDealerOutletType").find(":selected").text();
		selfDealer.TScreateDealerAge = $('#TScreateDealerAge').val();
		selfDealer.TScreateDealerEducation = $("#TScreateDealerEducation").find(":selected").text();
		selfDealer.TScreateDealerPreOccu = $('#TScreateDealerPreOccu').find(":selected").text();
		selfDealer.TScreateDealerFamilyBg = $('#TScreateDealerFamilyBg').find(":selected").text();
		selfDealer.TScreateDealerUniqueCode = $('#TScreateDealerUniqueCode').val();
		selfDealer.TScreateDealerPriLang = $('#TScreateDealerPriLang').find(":selected").text();
		selfDealer.TScreateDealerSecLang = $('#TScreateDealerSecLang').find(":selected").text();

		if(validated) {
			if(validateDropDown(selfDealer.TScreateDealerLocality,selfDealer.defaultTownLocality, Messages.invalidLocality)) {
				if(validateDropDown(selfDealer.TScreateDealerOutletType, selfDealer.defaultOutletType, Messages.invalidOutletType)) {
					if(selfDealer.TScreateDealerOutletType.substr(0,4) == "Sonu") {
						if(validateAge()) {
							if(validateDropDown(selfDealer.TScreateDealerEducation, selfDealer.defaultEducation, Messages.invalidEdu)) {
								if(validateDropDown(selfDealer.TScreateDealerPreOccu, selfDealer.defaultPrevOccu, Messages.invalidOccu)) {
									if(validateDropDown(selfDealer.TScreateDealerFamilyBg, selfDealer.defaultFamilyBG, Messages.invalidFamilyBG)) {
										if(validateUniqueCode()) {
											for (var i = 0; i < education.length; i++) {
												if(education[i].NAME == selfDealer.TScreateDealerEducation) {
													selfDealer.TScreateDealerEducationID = education[i].ID;
													break;
												}
											}
											
											for (var i = 0; i < prevOccupation.length; i++) {
												if(prevOccupation[i].NAME == selfDealer.TScreateDealerPreOccu) {
													selfDealer.TScreateDealerPreOccuID = prevOccupation[i].ID;
													break;
												}
											}
											
											for (var i = 0; i < familyBG.length; i++) {
												if(familyBG[i].NAME == selfDealer.TScreateDealerFamilyBg) {
													selfDealer.TScreateDealerFamilyBgID = familyBG[i].ID;
													break;
												}
											}
										} else return;
									} else return;
								} else return;
							} else return;
						} else return;
					}
					if(validateDropDown(selfDealer.TScreateDealerPriLang, selfDealer.defaultPriLang, Messages.invalidPriLang)) {
						if(validateDropDown(selfDealer.TScreateDealerSecLang, selfDealer.defaultSecLang, Messages.invalidSecLang)) {
							//Adding check for Mobile or Webuser. GPS validation done only for Mobile User
							if(((userOS == "Android") || (userOS == "iOS") && (typeof (cordova) == "object")) && !validateGPS) {
								showAlert("alert", Messages.gpsNotCaptured);
							} else {
								for (var i = 0; i < fosOutlet.length; i++) {
									if(fosOutlet[i].OUTLET_TYPE == selfDealer.TScreateDealerOutletType) {
										selfDealer.TScreateDealerOutletID = fosOutlet[i].OUTLET_ID;
										break;
									}
								}

								for (var i = 0; i < languages.length; i++) {
									if(languages[i].LANGUAGE_NAME == selfDealer.TScreateDealerPriLang) {
										selfDealer.TScreateDealerPriLangID = languages[i].LANGUAGE_ID;
										break;
									}
								}

								for (var i = 0; i < languages.length; i++) {
									if(languages[i].LANGUAGE_NAME == selfDealer.TScreateDealerSecLang) {
										selfDealer.TScreateDealerSecLangID = languages[i].LANGUAGE_ID;
										break;
									}
								}

								var parameters = [
									loginObj.userName,
									selfDealer.TScreateDealerDistMDN,
									selfDealer.TScreateFOSRoleID,
									selfDealer.TScreateDealerCircleID,
									selfDealer.TScreateDealerName,
									selfDealer.TScreateDealerNumber,
									selfDealer.TScreateDealerDirectSale,
									selfDealer.TScreateDealerOutletID,
									selfDealer.TScreateDealerAddress1,
									selfDealer.TScreateDealerAddress2,
									selfDealer.TScreateDealerPinCode,
									selfDealer.TScreateDealerEmail,
									selfDealer.TScreateDealerCity,
									selfDealer.TScreateDealerPriLangID,
									selfDealer.TScreateDealerDistrict,
									selfDealer.TScreateDealerSecLangID,
									selfDealer.TScreateDealerLocality,
									selfDealer.TScreateDealerTownCode,
									selfDealer.TScreateDealerAge,
									selfDealer.TScreateDealerEducationID,
									selfDealer.TScreateDealerFamilyBgID,
									selfDealer.TScreateDealerPreOccuID,
									userOS,
									selfDealer.TScreateDealerLatitude,
									selfDealer.TScreateDealerLongitude,
									selfDealer.TScreateDealerUniqueCode
								];
								selfDealer.submitDealerForm(configObj.adapter.FosDealerCreation, configObj.procedure.createDealersAccount, parameters)
							}
						}
					}
				}
			}
		} else {
			showAlert("alert", Messages.validationNotDone);
		}
	} catch (ex) {
		console.log(ex);
		showAlert("error", Messages.catchError);
		return;
	}
}

CreateDealer.prototype.submitDealerForm = function (adapterName, procedureName, parameters) {
	try {
		serviceObj.callAdapter(adapterName, procedureName, parameters, configObj.modules.submitDealerForm);
	} catch (ex) {
		console.log(ex);
		showAlert("error", Messages.catchError);
		return;
	}
}

CreateDealer.prototype.submitDealerFormSuccess = function (res){
	try {
		showAlert("message", "Dealer Created successfully. The Dealer ID is " + res.dealerId.DlrUserID, function (e) {
			e.stopImmediatePropagation();
			CommonFunctions.goToHomeScreen();
			CommonFunctions.resetFields();
		});
	} catch (ex) {
		console.log(ex);
		showAlert("error", Messages.catchError);
		return;
	}
}

CreateDealer.prototype.submitDealerFormFailure = function (res) {
	try {
		console.log(JSON.stringify(res));
		if(commonObj.isVisible()) {
			commonObj.hideBusy();
		}
		if (res.status == "failure") {
			showAlert("error", res.errorMessage);
		}
	} catch (ex) {
		console.log(ex);
	}
}


function validateDropDown(dropDownVariable, defaultText, message) {
	if (dropDownVariable == defaultText) {
		showAlert("alert", message);
		return false;
	} else return true;
}

function validateAge() {
	var regexNumber = /^[0-9]*$/;

	if (selfDealer.TScreateDealerAge == "") {
		showAlert("alert", Messages.emptyAge);
		return false;
	} else {
		if(!regexNumber.test(selfDealer.TScreateDealerAge)) {
			showAlert("alert", Messages.validAge);
			return false;
		} else return true;
	}
}

function validateUniqueCode() {
	// var regexUniqueCode = /^[0-9 _,]*$/;
	var regexUniqueCode = /^[0-9,\s]+$/;

	if(selfDealer.TScreateDealerUniqueCode === "") {
		showAlert("alert",Messages.emptyUniqueCode);
		return false;
	} else {
		if(!regexUniqueCode.test(selfDealer.TScreateDealerUniqueCode)) {
			showAlert("alert",Messages.validUniqueCode);
			return false;
		} else return true;
	}
}

var geoOpt = {
	enableHighAccuracy: false,
	timeout: 30000,
	maximumAge: 0
};

CreateDealer.prototype.getGeoLocation = function() {
	commonObj.showBusy();
	if (navigator.geolocation) {
		navigator.geolocation.getCurrentPosition(onLocSuccess, onLocFailure, geoOpt);
	} else {
		commonObj.hideBusy();
		showAlert("error", Messages.geolocationError);
	}
}

function onLocSuccess(position) {
	validateGPS = true;
	commonObj.hideBusy();
	selfDealer.TScreateDealerLatitude = position.coords.latitude;
	selfDealer.TScreateDealerLongitude = position.coords.longitude;
	$("#TScreateDealerLatitude").val(selfDealer.TScreateDealerLatitude);
	$("#TScreateDealerLongitude").val(selfDealer.TScreateDealerLongitude);
}

function onLocFailure(error) {
	commonObj.hideBusy();
	console.log(error);
	showAlert("error", Messages.locationCaptureError);
}

$(document).on("keypress", "#TScreateDealerName", function (e) {
	try {
		e.stopImmediatePropagation();
		var val = $(this).val();

		userNameAuth = validationObj.checkFisrtChar(val);
		if (userNameAuth === "numeric") {
			if (validationObj.firstZero(e, val)) {
				if (validationObj.isMaxLenght(e, this.id, configObj.maxLenght.mobile)) {
					validationObj.isNumber(e, val);
				}
			}
		} else if (userNameAuth === "alpha") {
			validationObj.alphaNumeric(val);
		} else {
			validationObj.firstSpecialChar(e, val);
		}
	} catch (ex) {
		if (userOS == "Windows" || env === "blackberry") {
			hideBusy();
		}
		if (commonObj.isVisible()) {
			commonObj.hideBusy();
		};
		showAlert("error", Messages.catchError);
		return;
	}
});

$(document).on("keypress","#TScreateDealerNumber", function(e){
	try {
		var val = $(this).val();
		if(validationObj.firstZero(e, val)) {
			 if(validationObj.isMaxLenght(e, this.id, configObj.maxLenght.mobile)){
				validationObj.isNumber(e, val);
			}
		}	
	} catch (ex) {
		showAlert("error", Messages.catchError);
		return;
	}
});

$(document).on("keypress","#TScreateDealerPinCode",function(e){
	e.stopImmediatePropagation();
	var val = $(this).val();
	if(validationObj.isMaxLenght(e, this.id, configObj.maxLenght.pincode)) {
		validationObj.isNumber(e, val);
	}
});

$(document).on("keypress","#TScreateDealerAge",function(e){
	e.stopImmediatePropagation();
	var val = $(this).val();
	if(validationObj.isMaxLenght(e, this.id, configObj.maxLenght.age)) {
		validationObj.isNumber(e, val);
	}
});

$(document).on("keypress","#TScreateDealerUniqueCode",function(evt){
	evt.stopImmediatePropagation();
	var theEvent = evt || window.event;
	var key = theEvent.keyCode || theEvent.which;
	var keyCode = key;
	key = String.fromCharCode(key);
	if (key.length == 0) return;
	var regex = /^[0-9,\s\b]+$/;
	if(keyCode == 188 || keyCode == 190) {
		return;
	} else {
		if (!regex.test(key)) {
			theEvent.returnValue = false;
			if (theEvent.preventDefault) theEvent.preventDefault();
		}
	}
});

$(document).ready(function () {
	$(document).on('click', '#TScreateDealerValidate', selfDealer.validate);
	$(document).on('click', '#TScreateDealerSubmit', selfDealer.validateDealerForm);

	$("#TScreateDealerLocality").on("change",function() {
		if(this.value == "") {
			showAlert("alert", Messages.invalidLocality);
			resetDropDowns("#TScreateDealerOutletType", selfDealer.defaultOutletType);
			resetDropDowns("#TScreateDealerPriLang", selfDealer.defaultPriLang);
			resetDropDowns("#TScreateDealerSecLang", selfDealer.defaultSecLang);
		} else {
			selfDealer.TScreateDealerLocality = this.value;
			var parameter = [loginObj.userName, selfDealer.TScreateDealerPinCode, selfDealer.TScreateDealerLocality];
			dealerInfoObj.localityCheck(configObj.adapter.FosDealerCreation, configObj.procedure.validateTownCode, parameter,configObj.modules.checkTownLocality);
		}
	});

	$("#TScreateDealerOutletType").on("change",function() {
		if(this.value == "") {
			showAlert("alert", Messages.invalidOutletType);
			resetDropDowns("#TScreateDealerPriLang", selfDealer.defaultPriLang);
			resetDropDowns("#TScreateDealerSecLang", selfDealer.defaultSecLang);
		} else {
			selfDealer.TScreateDealerOutletType = this.value;
			var parameter = [loginObj.userName, selfDealer.TScreateDealerOutletType, selfDealer.TScreateDealerPinCode, selfDealer.TScreateDealerCircle, selfDealer.TScreateDealerLocality];
			dealerInfoObj.selectOutletType(configObj.adapter.FosDealerCreation, configObj.procedure.validateForOutletType, parameter);
		}
	});

	$(document).on(	'click','#TScreateDealerCancel',function() {
		CommonFunctions.onModuleCancel();
		CommonFunctions.resetFields();
	});

	$(document).on('click','#geoLocationCapture',function() {
		selfDealer.getGeoLocation();
	});

	//Ask user to Re-validate the form if changes are made after clicking on "Validate" button and trying to submit without validating again
	$("#TScreateDealerName, #TScreateDealerNumber, #TScreateDealerEmail, #TScreateDealerDirectSale, #TScreateDealerAddress1, #TScreateDealerAddress2, #TScreateDealerPinCode").on("change",function() {
		if(validated) {
			validated = false;
		}
	});
});
