/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var busyInd, serviceObj,configObj, alertObj, env, geoBusyInd;
var wlInitOptions = {
    // Options to initialize with the WL.Client object.
    // For initialization options please refer to IBM MobileFirst Platform Foundation Knowledge Center.
     mfpContextRoot : '/mfp', // "mfp" is the default context root in the MobileFirst Development server
      applicationId : 'com.SalesAndPartner', // Replace with your own app id/package name.
      //connectOnStartup : false,
      timeout: 60000,
      //logger : {enabled: true, level: 'debug', stringify: true, pretty: false,
        //tag: {level: false, pkg: true}, whitelist: [], blacklist: []},
        analytics : {
            enabled: true
            //url : ''
        }
  };

if (document.addEventListener) {
    document.addEventListener("deviceready", onDeviceReady, false);
    function onDeviceReady() {
        document.addEventListener("backbutton", onBackKeyDown, false);
        window.open = cordova.InAppBrowser.open;
    };
    document.addEventListener('mfpready', function () {
        WL.Client.init(wlInitOptions);
    }, false);
} else {
    if (window.attachEvent) {
        document.attachEvent('mfpready', function () {
            WL.Client.init(wlInitOptions);
        });
    }
}

function wlCommonInit() {
    //disable console.log and alert
    console.log = function(){return;};
    alert = function(){return;};
    
    console.log("inside wlCommonInit");

    /* wl_DirectUpdateChallengeHandler.handleDirectUpdate = function(directUpdateData, directUpdateContext) {
    // Implement custom Direct Update logic
    };  */

    app.initialize();
}

var app = {
    // Application Constructor
    initialize: function() {
        var obj = new Common();
        configObj = new Configuration();
        serviceObj = new webService();
        busyInd = obj;
        geoBusyInd = obj;
        commonObj.showBusy();
        //busyInd = new WL.BusyIndicator('busyIndicator', {text : 'Loading...', fullScreen : true, opacity : 0.85});
        //geoBusyInd= new WL.BusyIndicator('busyIndicator', {text : 'Please wait...', fullScreen : true, opacity : 0.85});
        // Common initialization code goes here
       
        setTimeout(function(){ 
            if(userOS !="Android"){
                console.log("not android");
                initializePushNotification();
                if(isJSONStoreSupported() === true){
                    env = device.platform;
                    $("#userName").addClass("ui-disabled");
                    $("#password").addClass("ui-disabled");
                    dbHelper = new DatabaseHelper();
                    dbHelper.initJSONStore();		
                }
                else if(isJSONStoreSupported() === false)
                {
                    //env = WL.Client.getEnvironment();
                    env = device.platform; //newly added
                    if(env === 'windowsphone8')
                    {
                        dbHelper = new DatabaseHelper();
                        dbHelper.initializeWindowsDB();
                    }
                    else if(env === 'blackberry')
                    {
                        dbHelper = new DatabaseHelper();
                        dbHelper.initializeBlackberryDB();
                    }
                    else if(env === 'blackberry10')
                    {
                        dbHelper = new DatabaseHelper();
                        dbHelper.initializeBlackberry10DB();
                    }
                }
            } else{
                console.log("android");
                env = device.platform;
                $("#userName").addClass("ui-disabled");
                $("#password").addClass("ui-disabled");
                dbHelper.androidAutoLoginCheck();
            }
        }, 3000);
        
       
        document.addEventListener("online", obj.onApplicationOnline, false);
        document.addEventListener('hidekeyboard', onKeyboardHide, false);
        console.log("app.initialize() success");
        //document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        this.receivedEvent('deviceready');
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');

        console.log('Received Event: ' + id);
    }
};

var mfpInitProperties = {
    'mfpContextRoot' : '/mfp' ,
    'applicationId' : 'com.SalesAndPartner',
    'sessionMode' : true
};
// WL.Client.init(mfpInitProperties).then
// (function(){
//     console.log('MobileFirst web SDK initialized');
//     // Application initialization logic
// });

require.config({
	'paths': {
		'mfp': 'node_modules/ibm-mfp-web-sdk/ibmmfpf'
	}
});

require(['mfp'], function(WL) {
    // application logic.
});